Index: install.cc
===================================================================
RCS file: /cvs/src/src/winsup/cinstall/install.cc,v
retrieving revision 2.31
diff -u -p -r2.31 install.cc
--- install.cc	2001/12/20 11:49:53	2.31
+++ install.cc	2001/12/20 12:36:00
@@ -33,6 +33,8 @@ static const char *cvsid =
 #include <sys/types.h>
 #include <sys/stat.h>
 #include <errno.h>
+#include <process.h>
+
 #include "zlib/zlib.h"
 
 #include "resource.h"
@@ -61,109 +63,31 @@ static const char *cvsid =
 
 #include "port.h"
 
-static HWND ins_dialog = 0;
-static HWND ins_action = 0;
-static HWND ins_pkgname = 0;
-static HWND ins_filename = 0;
-static HWND ins_pprogress = 0;
-static HWND ins_iprogress = 0;
-static HWND ins_diskfull = 0;
-static HANDLE init_event;
+#include "threebar.h"
+extern ThreeBarProgressPage Progress;
 
 static int total_bytes = 0;
 static int total_bytes_sofar = 0;
 static int package_bytes = 0;
 
-static bool
-dialog_cmd (HWND h, int id, HWND hwndctl, UINT code)
-{
-  switch (id)
-    {
-    case IDCANCEL:
-      exit_setup (1);
-    }
-  return 0;
-}
-
-static BOOL CALLBACK
-dialog_proc (HWND h, UINT message, WPARAM wParam, LPARAM lParam)
-{
-  switch (message)
-    {
-    case WM_INITDIALOG:
-      ins_dialog = h;
-      ins_action = GetDlgItem (h, IDC_INS_ACTION);
-      ins_pkgname = GetDlgItem (h, IDC_INS_PKG);
-      ins_filename = GetDlgItem (h, IDC_INS_FILE);
-      ins_pprogress = GetDlgItem (h, IDC_INS_PPROGRESS);
-      ins_iprogress = GetDlgItem (h, IDC_INS_IPROGRESS);
-      ins_diskfull = GetDlgItem (h, IDC_INS_DISKFULL);
-      SetEvent (init_event);
-      return TRUE;
-    case WM_COMMAND:
-      return HANDLE_WM_COMMAND (h, wParam, lParam, dialog_cmd);
-    }
-  return FALSE;
-}
-
-static WINAPI DWORD
-dialog (void *)
-{
-  int rv = 0;
-  MSG m;
-  HWND ins_dialog = CreateDialog (hinstance, MAKEINTRESOURCE (IDD_INSTATUS),
-				  0, dialog_proc);
-  if (ins_dialog == 0)
-    fatal ("create dialog");
-  ShowWindow (ins_dialog, SW_SHOWNORMAL);
-  UpdateWindow (ins_dialog);
-  while (GetMessage (&m, 0, 0, 0) > 0)
-    {
-      TranslateMessage (&m);
-      DispatchMessage (&m);
-    }
-  return rv;
-}
-
 static void
 init_dialog ()
 {
-  if (ins_dialog == 0)
-    {
-      DWORD tid;
-      HANDLE thread;
-      init_event = CreateEvent (0, 0, 0, 0);
-      thread = CreateThread (0, 0, dialog, 0, 0, &tid);
-      WaitForSingleObject (init_event, 10000);
-      CloseHandle (init_event);
-      SendMessage (ins_pprogress, PBM_SETRANGE, 0, MAKELPARAM (0, 100));
-      SendMessage (ins_iprogress, PBM_SETRANGE, 0, MAKELPARAM (0, 100));
-      SendMessage (ins_diskfull, PBM_SETRANGE, 0, MAKELPARAM (0, 100));
-    }
-
-  SetWindowText (ins_pkgname, "");
-  SetWindowText (ins_filename, "");
-  SendMessage (ins_pprogress, PBM_SETPOS, (WPARAM) 0, 0);
-  SendMessage (ins_iprogress, PBM_SETPOS, (WPARAM) 0, 0);
-  SendMessage (ins_diskfull, PBM_SETPOS, (WPARAM) 0, 0);
-  ShowWindow (ins_dialog, SW_SHOWNORMAL);
+  Progress.SetText2 ("");
+  Progress.SetText3 ("");
 }
 
 static void
 progress (int bytes)
 {
-  int perc;
-
-  if (package_bytes > 100)
+  if (package_bytes > 0)
     {
-      perc = bytes / (package_bytes / 100);
-      SendMessage (ins_pprogress, PBM_SETPOS, (WPARAM) perc, 0);
+      Progress.SetBar1 (bytes, package_bytes);
     }
 
-  if (total_bytes > 100)
+  if (total_bytes > 0)
     {
-      perc = (total_bytes_sofar + bytes) / (total_bytes / 100);
-      SendMessage (ins_iprogress, PBM_SETPOS, (WPARAM) perc, 0);
+      Progress.SetBar2 (total_bytes_sofar + bytes, total_bytes);
     }
 }
 
@@ -192,11 +116,11 @@ static int num_installs, num_uninstalls;
 static void
 uninstall_one (packagemeta & pkgm)
 {
-      SetWindowText (ins_pkgname, pkgm.name);
-      SetWindowText (ins_action, "Uninstalling...");
-      log (0, "Uninstalling %s", pkgm.name);
-      pkgm.uninstall ();
-      num_uninstalls++;
+  Progress.SetText1 ("Uninstalling...");
+  Progress.SetText2 (pkgm.name);
+  log (0, "Uninstalling %s", pkgm.name);
+  pkgm.uninstall ();
+  num_uninstalls++;
 }
 
 
@@ -207,10 +131,10 @@ install_one_source (packagemeta & pkgm, 
 		    char const *prefix, package_type_t type)
 {
   int errors = 0;
-  SetWindowText (ins_pkgname, source.Base ());
+  Progress.SetText2 (source.Base ());
   if (!io_stream::exists (source.Cached ()))
     {
-      note (IDS_ERR_OPEN_READ, source.Cached (), "No such file");
+      note (NULL, IDS_ERR_OPEN_READ, source.Cached (), "No such file");
       return 1;
     }
   io_stream *lst = 0;
@@ -232,7 +156,7 @@ install_one_source (packagemeta & pkgm, 
 
   char msg[64];
   strcpy (msg, "Installing");
-  SetWindowText (ins_action, msg);
+  Progress.SetText1 (msg);
   log (0, "%s%s", msg, source.Cached ());
   io_stream *tmp = io_stream::open (source.Cached (), "rb");
   archive *thefile = 0;
@@ -254,7 +178,7 @@ install_one_source (packagemeta & pkgm, 
 	    lst->write (concat (fn, "\n", 0), strlen (fn) + 1);
 
 	  /* FIXME: concat leaks memory */
-	  SetWindowText (ins_filename, concat (prefix, fn, 0));
+	  Progress.SetText3 (concat (prefix, fn, 0));
 	  log (LOG_BABBLE, "Installing file %s%s", prefix, fn);
 	  if (archive::extract_file (thefile, prefix) != 0)
 	    {
@@ -274,7 +198,7 @@ install_one_source (packagemeta & pkgm, 
   progress (0);
 
   int df = diskfull (get_root_dir ());
-  SendMessage (ins_diskfull, PBM_SETPOS, (WPARAM) df, 0);
+  Progress.SetBar3 (df);
 
   if (lst)
     delete lst;
@@ -289,17 +213,17 @@ install_one (packagemeta & pkg)
   int errors = 0;
 
   if (pkg.desired->binpicked)
-  {
-    errors +=
-      install_one_source (pkg, pkg.desired->bin, "cygfile:///",
-			  package_binary);
-    if (!errors)
-      pkg.installed = pkg.desired;
-  }
-  if (pkg.desired->srcpicked)
+    {
       errors +=
-	    install_one_source (pkg, pkg.desired->src, "cygfile:///usr/src",
-		                        package_source);
+	install_one_source (pkg, pkg.desired->bin, "cygfile:///",
+			    package_binary);
+      if (!errors)
+	pkg.installed = pkg.desired;
+    }
+  if (pkg.desired->srcpicked)
+    errors +=
+      install_one_source (pkg, pkg.desired->src, "cygfile:///usr/src",
+			  package_source);
 
   /* FIXME: make a upgrade method and reinstate this */
 #if 0
@@ -375,8 +299,8 @@ check_for_old_cygwin ()
   return;
 }
 
-void
-do_install (HINSTANCE h)
+static void
+do_install_thread (HINSTANCE h, HWND owner)
 {
   int i;
   int errors = 0;
@@ -398,15 +322,13 @@ do_install (HINSTANCE h)
   io_stream *utmp = io_stream::open ("cygfile:///var/run/utmp", "wb");
   delete utmp;
 
-  dismiss_url_status_dialog ();
-
   init_dialog ();
 
   total_bytes = 0;
   total_bytes_sofar = 0;
 
   int df = diskfull (get_root_dir ());
-  SendMessage (ins_diskfull, PBM_SETPOS, (WPARAM) df, 0);
+  Progress.SetBar3 (df);
 
   int istext = (root_text == IDC_ROOT_TEXT) ? 1 : 0;
   int issystem = (root_scope == IDC_ROOT_SYSTEM) ? 1 : 0;
@@ -419,27 +341,26 @@ do_install (HINSTANCE h)
   packagedb db;
   for (size_t n = 1; n < db.packages.number (); n++)
     {
-      packagemeta &pkg = * db.packages[n];
+      packagemeta & pkg = *db.packages[n];
 
-    if (pkg.desired && (pkg.desired->srcpicked || pkg.desired->binpicked))
-      {
-	if (pkg.desired->srcpicked)
-	  total_bytes += pkg.desired->src.size;
-	if (pkg.desired->binpicked)
-	  total_bytes += pkg.desired->bin.size;
-      }
+      if (pkg.desired && (pkg.desired->srcpicked || pkg.desired->binpicked))
+	{
+	  if (pkg.desired->srcpicked)
+	    total_bytes += pkg.desired->src.size;
+	  if (pkg.desired->binpicked)
+	    total_bytes += pkg.desired->bin.size;
+	}
     }
 
   for (size_t n = 1; n < db.packages.number (); n++)
     {
-      packagemeta &pkg = * db.packages[n];
+      packagemeta & pkg = *db.packages[n];
       if (pkg.installed && (!pkg.desired || pkg.desired != pkg.installed))
 	{
 	  uninstall_one (pkg);
 	}
 
-      if (pkg.desired
-	  && (pkg.desired->srcpicked || pkg.desired->binpicked))
+      if (pkg.desired && (pkg.desired->srcpicked || pkg.desired->binpicked))
 	{
 	  int e = 0;
 	  e += install_one (pkg);
@@ -450,15 +371,13 @@ do_install (HINSTANCE h)
 	}
     }				// end of big package loop
 
-  ShowWindow (ins_dialog, SW_HIDE);
-
   int temperr;
   if ((temperr = db.flush ()))
     {
       const char *err = strerror (temperr);
       if (!err)
 	err = "(unknown error)";
-      fatal (IDS_ERR_OPEN_WRITE, err);
+      fatal (owner, IDS_ERR_OPEN_WRITE, err);
     }
 
   if (!errors)
@@ -478,4 +397,29 @@ do_install (HINSTANCE h)
     exit_msg = IDS_INSTALL_INCOMPLETE;
   else
     exit_msg = IDS_INSTALL_COMPLETE;
+}
+
+static void
+do_install_reflector (void *p)
+{
+  HANDLE *context;
+  context = (HANDLE *) p;
+
+  do_install_thread ((HINSTANCE) context[0], (HWND) context[1]);
+
+  // Tell the progress page that we're done downloading
+  Progress.PostMessage (WM_APP_INSTALL_THREAD_COMPLETE, next_dialog);
+
+  _endthread ();
+}
+
+static HANDLE context[2];
+
+void
+do_install (HINSTANCE h, HWND owner)
+{
+  context[0] = h;
+  context[1] = owner;
+
+  _beginthread (do_install_reflector, 0, context);
 }
Index: localdir.cc
===================================================================
RCS file: /cvs/src/src/winsup/cinstall/localdir.cc,v
retrieving revision 2.5
diff -u -p -r2.5 localdir.cc
--- localdir.cc	2001/11/14 00:11:35	2.5
+++ localdir.cc	2001/12/20 12:36:00
@@ -39,6 +39,8 @@ static const char *cvsid =
 #include "mkdir.h"
 #include "io_stream.h"
 
+#include "localdir.h"
+
 void
 save_local_dir ()
 {
@@ -128,74 +130,20 @@ dialog_cmd (HWND h, int id, HWND hwndctl
     case IDC_LOCAL_DIR_BROWSE:
       browse (h);
       break;
-
-    case IDOK:
-      save_dialog (h);
-      save_local_dir ();
-      if (SetCurrentDirectoryA (local_dir))
-	{
-	  switch (source)
-	    {
-	    case IDC_SOURCE_DOWNLOAD:
-	    case IDC_SOURCE_NETINST:
-	      NEXT (IDD_NET);
-	      break;
-	    case IDC_SOURCE_CWD:
-	      NEXT (IDD_S_FROM_CWD);
-	      break;
-	    default:
-	      msg ("source is default? %d\n", source);
-	      NEXT (0);
-	      break;
-	    }
-	}
-      else
-	note (IDS_ERR_CHDIR, local_dir);
-
-      break;
-
-    case IDC_BACK:
-      save_dialog (h);
-      switch (source)
-	{
-	case IDC_SOURCE_DOWNLOAD:
-	  NEXT (IDD_SOURCE);
-	  break;
-	case IDC_SOURCE_NETINST:
-	case IDC_SOURCE_CWD:
-	  NEXT (IDD_ROOT);
-	  break;
-	default:
-	  msg ("source is default? %d\n", source);
-	  NEXT (0);
-	}
-      break;
-
-    case IDCANCEL:
-      NEXT (0);
-      break;
     }
   return 0;
 }
+
+//extern char cwd[_MAX_PATH];
 
-static BOOL CALLBACK
-dialog_proc (HWND h, UINT message, WPARAM wParam, LPARAM lParam)
+bool
+LocalDirPage::Create ()
 {
-  switch (message)
-    {
-    case WM_INITDIALOG:
-      load_dialog (h);
-      return FALSE;
-    case WM_COMMAND:
-      return HANDLE_WM_COMMAND (h, wParam, lParam, dialog_cmd);
-    }
-  return FALSE;
+  return PropertyPage::Create (NULL, dialog_cmd, IDD_LOCAL_DIR);
 }
 
-extern char cwd[_MAX_PATH];
-
 void
-do_local_dir (HINSTANCE h)
+LocalDirPage::OnInit ()
 {
   static int inited = 0;
   if (!inited)
@@ -217,11 +165,43 @@ do_local_dir (HINSTANCE h)
 	}
       inited = 1;
     }
+}
+
+void
+LocalDirPage::OnActivate ()
+{
+  load_dialog (GetHWND ());
+}
 
-  int rv = 0;
-  rv = DialogBox (h, MAKEINTRESOURCE (IDD_LOCAL_DIR), 0, dialog_proc);
-  if (rv == -1)
-    fatal (IDS_DIALOG_FAILED);
+long
+LocalDirPage::OnNext ()
+{
+  HWND h = GetHWND ();
 
+  save_dialog (h);
+  save_local_dir ();
   log (0, "Selected local directory: %s", local_dir);
+  if (SetCurrentDirectoryA (local_dir))
+    {
+      if (source == IDC_SOURCE_CWD)
+	{
+	  return IDD_S_FROM_CWD;
+	}
+    }
+  else
+    note (h, IDS_ERR_CHDIR, local_dir);
+
+  return 0;
+}
+
+long
+LocalDirPage::OnBack ()
+{
+  save_dialog (GetHWND ());
+  if (source == IDC_SOURCE_DOWNLOAD)
+    {
+      // Downloading only, skip the unix root page
+      return IDD_SOURCE;
+    }
+  return 0;
 }
Index: localdir.h
===================================================================
RCS file: localdir.h
diff -N localdir.h
--- /dev/null	Tue May  5 13:32:27 1998
+++ localdir.h	Thu Dec 20 04:36:00 2001
@@ -0,0 +1,44 @@
+#ifndef CINSTALL_LOCALDIR_H
+#define CINSTALL_LOCALDIR_H
+
+/*
+ * Copyright (c) 2001, Gary R. Van Sickle.
+ *
+ *     This program is free software; you can redistribute it and/or modify
+ *     it under the terms of the GNU General Public License as published by
+ *     the Free Software Foundation; either version 2 of the License, or
+ *     (at your option) any later version.
+ *
+ *     A copy of the GNU General Public License can be found at
+ *     http://www.gnu.org/
+ *
+ * Written by Gary R. Van Sickle <g.r.vansickle@worldnet.att.net>
+ *
+ */
+
+// This is the header for the LocalDirPage class.  Allows the user to select
+// the local package directory (i.e. where downloaded packages are stored).
+
+
+#include "proppage.h"
+
+class LocalDirPage:public PropertyPage
+{
+public:
+  LocalDirPage ()
+  {
+  };
+  virtual ~ LocalDirPage ()
+  {
+  };
+
+  bool Create ();
+
+  void OnActivate ();
+  void OnInit ();
+  long OnNext ();
+  long OnBack ();
+};
+
+
+#endif
Index: log.cc
===================================================================
RCS file: /cvs/src/src/winsup/cinstall/log.cc,v
retrieving revision 2.5
diff -u -p -r2.5 log.cc
--- log.cc	2001/11/13 01:49:32	2.5
+++ log.cc	2001/12/20 12:36:00
@@ -86,7 +86,7 @@ log_save (int babble, const char *filena
   FILE *f = fopen (filename, append ? "at" : "wt");
   if (!f)
     {
-      fatal (IDS_NOLOGFILE, filename);
+      fatal (NULL, IDS_NOLOGFILE, filename);
       return;
     }
 
@@ -115,7 +115,7 @@ exit_setup (int exit_code)
   been_here = 1;
 
   if (exit_msg)
-    note (exit_msg);
+    note (NULL, exit_msg);
 
   log (LOG_TIMESTAMP, "Ending cygwin install");
 
Index: main.cc
===================================================================
RCS file: /cvs/src/src/winsup/cinstall/main.cc,v
retrieving revision 2.9
diff -u -p -r2.9 main.cc
--- main.cc	2001/11/13 01:49:32	2.9
+++ main.cc	2001/12/20 12:36:00
@@ -29,6 +29,7 @@ static const char *cvsid =
 #endif
 
 #include "win32.h"
+#include <commctrl.h>
 
 #include <stdio.h>
 #include <stdlib.h>
@@ -42,7 +43,20 @@ static const char *cvsid =
 #include "version.h"
 
 #include "port.h"
+#include "proppage.h"
+#include "propsheet.h"
 
+// Page class headers
+#include "splash.h"
+#include "source.h"
+#include "root.h"
+#include "localdir.h"
+#include "net.h"
+#include "site.h"
+#include "choose.h"
+#include "threebar.h"
+#include "desktop.h"
+
 int next_dialog;
 int exit_msg = 0;
 
@@ -123,6 +137,12 @@ out:
   FreeSid (sid);
 }
 
+extern BOOL CALLBACK
+root_dialog_proc (HWND h, UINT message, WPARAM wParam, LPARAM lParam);
+
+// Other threads talk to this page, so we need to have it externable.
+ThreeBarProgressPage Progress;
+
 int WINAPI
 WinMain (HINSTANCE h,
 	 HINSTANCE hPrevInstance, LPSTR command_line, int cmd_show)
@@ -133,6 +153,16 @@ WinMain (HINSTANCE h,
 
   log (LOG_TIMESTAMP, "Starting cygwin install, version %s", version);
 
+  SplashPage Splash;
+  SourcePage Source;
+  RootPage Root;
+  LocalDirPage LocalDir;
+  NetPage Net;
+  SitePage Site;
+  ChooserPage Chooser;
+  DesktopSetupPage Desktop;
+  PropSheet MainWindow;
+
   char cwd[_MAX_PATH];
   GetCurrentDirectory (sizeof (cwd), cwd);
   local_dir = strdup (cwd);
@@ -150,58 +180,36 @@ WinMain (HINSTANCE h,
   if (iswinnt)
     set_default_dacl ();
 
-  while (next_dialog)
-    {
-      switch (next_dialog)
-	{
-	case IDD_SPLASH:
-	  do_splash (h);
-	  break;
-	case IDD_SOURCE:
-	  do_source (h);
-	  break;
-	case IDD_LOCAL_DIR:
-	  do_local_dir (h);
-	  break;
-	case IDD_ROOT:
-	  do_root (h);
-	  break;
-	case IDD_NET:
-	  do_net (h);
-	  break;
-	case IDD_SITE:
-	  do_site (h);
-	  break;
-	case IDD_OTHER_URL:
-	  do_other (h);
-	  break;
-	case IDD_S_LOAD_INI:
-	  do_ini (h);
-	  break;
-	case IDD_S_FROM_CWD:
-	  do_fromcwd (h);
-	  break;
-	case IDD_CHOOSE:
-	  do_choose (h);
-	  break;
-	case IDD_S_DOWNLOAD:
-	  do_download (h);
-	  break;
-	case IDD_S_INSTALL:
-	  do_install (h);
-	  break;
-	case IDD_DESKTOP:
-	  do_desktop (h);
-	  break;
-	case IDD_S_POSTINSTALL:
-	  do_postinstall (h);
-	  break;
-
-	default:
-	  next_dialog = 0;
-	  break;
-	}
-    }
+  // Initialize common controls
+  InitCommonControls ();
+
+  // Init window class lib
+  Window::SetAppInstance (h);
+
+  // Create pages
+  Splash.Create ();
+  Source.Create ();
+  Root.Create ();
+  LocalDir.Create ();
+  Net.Create ();
+  Site.Create ();
+  Chooser.Create ();
+  Progress.Create ();
+  Desktop.Create ();
+
+  // Add pages to sheet
+  MainWindow.AddPage (&Splash);
+  MainWindow.AddPage (&Source);
+  MainWindow.AddPage (&Root);
+  MainWindow.AddPage (&LocalDir);
+  MainWindow.AddPage (&Net);
+  MainWindow.AddPage (&Site);
+  MainWindow.AddPage (&Chooser);
+  MainWindow.AddPage (&Progress);
+  MainWindow.AddPage (&Desktop);
+
+  // Create the PropSheet main window
+  MainWindow.Create ();
 
   exit_setup (0);
   /* Keep gcc happy :} */
Index: msg.cc
===================================================================
RCS file: /cvs/src/src/winsup/cinstall/msg.cc,v
retrieving revision 2.2
diff -u -p -r2.2 msg.cc
--- msg.cc	2001/11/13 01:49:32	2.2
+++ msg.cc	2001/12/20 12:36:00
@@ -38,7 +38,7 @@ msg (const char *fmt, ...)
 }
 
 static int
-mbox (const char *name, int type, int id, va_list args)
+mbox (HWND owner, const char *name, int type, int id, va_list args)
 {
   char buf[1000], fmt[1000];
 
@@ -47,30 +47,30 @@ mbox (const char *name, int type, int id
 
   vsprintf (buf, fmt, args);
   log (0, "mbox %s: %s", name, buf);
-  return MessageBox (0, buf, "Cygwin Setup", type | MB_TOPMOST);
+  return MessageBox (owner, buf, "Cygwin Setup", type /*| MB_TOPMOST */ );
 }
 
 void
-note (int id, ...)
+note (HWND owner, int id, ...)
 {
   va_list args;
   va_start (args, id);
-  mbox ("note", 0, id, args);
+  mbox (owner, "note", 0, id, args);
 }
 
 void
-fatal (int id, ...)
+fatal (HWND owner, int id, ...)
 {
   va_list args;
   va_start (args, id);
-  mbox ("fatal", 0, id, args);
+  mbox (owner, "fatal", 0, id, args);
   exit_setup (1);
 }
 
 int
-yesno (int id, ...)
+yesno (HWND owner, int id, ...)
 {
   va_list args;
   va_start (args, id);
-  return mbox ("yesno", MB_YESNO, id, args);
+  return mbox (owner, "yesno", MB_YESNO, id, args);
 }
Index: msg.h
===================================================================
RCS file: /cvs/src/src/winsup/cinstall/msg.h,v
retrieving revision 2.1
diff -u -p -r2.1 msg.h
--- msg.h	2001/11/13 01:49:32	2.1
+++ msg.h	2001/12/20 12:36:00
@@ -23,11 +23,11 @@ void msg (const char *fmt, ...);
    is interpreted like printf.  The program exits when the user
    presses OK. */
 
-void fatal (int id, ...);
+void fatal (HWND owner, int id, ...);
 
 /* Similar, but the program continues when the user presses OK */
 
-void note (int id, ...);
+void note (HWND owner, int id, ...);
 
 /* returns IDYES or IDNO, otherwise same as note() */
-int yesno (int id, ...);
+int yesno (HWND owner, int id, ...);
Index: net.cc
===================================================================
RCS file: /cvs/src/src/winsup/cinstall/net.cc,v
retrieving revision 2.7
diff -u -p -r2.7 net.cc
--- net.cc	2001/11/13 01:49:32	2.7
+++ net.cc	2001/12/20 12:36:00
@@ -30,6 +30,11 @@ static const char *cvsid =
 #include "msg.h"
 #include "log.h"
 
+#include "net.h"
+
+#include "threebar.h"
+extern ThreeBarProgressPage Progress;
+
 static int rb[] = { IDC_NET_IE5, IDC_NET_DIRECT, IDC_NET_PROXY, 0 };
 
 static void
@@ -84,71 +89,50 @@ dialog_cmd (HWND h, int id, HWND hwndctl
       save_dialog (h);
       check_if_enable_next (h);
       break;
-
-    case IDOK:
-      save_dialog (h);
-      switch (source)
-	{
-	case IDC_SOURCE_NETINST:
-	case IDC_SOURCE_DOWNLOAD:
-	  NEXT (IDD_SITE);
-	  break;
-	case IDC_SOURCE_CWD:
-	  NEXT (0);
-	  break;
-	default:
-	  msg ("source is default? %d\n", source);
-	  NEXT (0);
-	}
-      break;
-
-    case IDC_BACK:
-      save_dialog (h);
-      NEXT (IDD_LOCAL_DIR);
-      break;
-
-    case IDCANCEL:
-      NEXT (0);
-      break;
     }
   return 0;
 }
 
-static BOOL CALLBACK
-dialog_proc (HWND h, UINT message, WPARAM wParam, LPARAM lParam)
+bool
+NetPage::Create ()
 {
-  switch (message)
-    {
-    case WM_INITDIALOG:
-      load_dialog (h);
-
-      // Check to see if any radio buttons are selected. If not, select a default.
-      if (
-	  (!SendMessage (GetDlgItem (h, IDC_NET_IE5), BM_GETCHECK, 0, 0) ==
-	   BST_CHECKED)
-	  && (!SendMessage (GetDlgItem (h, IDC_NET_PROXY), BM_GETCHECK, 0, 0)
-	      == BST_CHECKED))
-	{
-	  SendMessage (GetDlgItem (h, IDC_NET_DIRECT), BM_CLICK, 0, 0);
-	}
-      return FALSE;
-    case WM_COMMAND:
-      return HANDLE_WM_COMMAND (h, wParam, lParam, dialog_cmd);
-    }
-  return FALSE;
+  return PropertyPage::Create (NULL, dialog_cmd, IDD_NET);
 }
 
 void
-do_net (HINSTANCE h)
+NetPage::OnInit ()
 {
-  int rv = 0;
+  HWND h = GetHWND ();
 
   net_method = IDC_NET_DIRECT;
-  rv = DialogBox (h, MAKEINTRESOURCE (IDD_NET), 0, dialog_proc);
-  if (rv == -1)
-    fatal (IDS_DIALOG_FAILED);
+  load_dialog (h);
+
+  // Check to see if any radio buttons are selected. If not, select a default.
+  if ((!SendMessage (GetDlgItem (IDC_NET_IE5), BM_GETCHECK, 0, 0) ==
+       BST_CHECKED)
+      && (!SendMessage (GetDlgItem (IDC_NET_PROXY), BM_GETCHECK, 0, 0)
+	  == BST_CHECKED))
+    {
+      SendMessage (GetDlgItem (IDC_NET_DIRECT), BM_CLICK, 0, 0);
+    }
+}
+
+long
+NetPage::OnNext ()
+{
+  save_dialog (GetHWND ());
 
   log (0, "net: %s",
        (net_method == IDC_NET_IE5) ? "IE5" :
        (net_method == IDC_NET_DIRECT) ? "Direct" : "Proxy");
+
+  Progress.SetActivateTask (WM_APP_START_SITE_INFO_DOWNLOAD);
+  return IDD_INSTATUS;
+}
+
+long
+NetPage::OnBack ()
+{
+  save_dialog (GetHWND ());
+  return 0;
 }
Index: net.h
===================================================================
RCS file: net.h
diff -N net.h
--- /dev/null	Tue May  5 13:32:27 1998
+++ net.h	Thu Dec 20 04:36:00 2001
@@ -0,0 +1,42 @@
+#ifndef CINSTALL_NET_H
+#define CINSTALL_NET_H
+
+/*
+ * Copyright (c) 2001, Gary R. Van Sickle.
+ *
+ *     This program is free software; you can redistribute it and/or modify
+ *     it under the terms of the GNU General Public License as published by
+ *     the Free Software Foundation; either version 2 of the License, or
+ *     (at your option) any later version.
+ *
+ *     A copy of the GNU General Public License can be found at
+ *     http://www.gnu.org/
+ *
+ * Written by Gary R. Van Sickle <g.r.vansickle@worldnet.att.net>
+ *
+ */
+
+// This is the header for the NetPage class.  It allows the user to select
+// a proxy etc.
+
+
+#include "proppage.h"
+
+class NetPage:public PropertyPage
+{
+public:
+  NetPage ()
+  {
+  };
+  virtual ~ NetPage ()
+  {
+  };
+
+  bool Create ();
+
+  virtual void OnInit ();
+  virtual long OnNext ();
+  virtual long OnBack ();
+};
+
+#endif // CINSTALL_NET_H
Index: netio.cc
===================================================================
RCS file: /cvs/src/src/winsup/cinstall/netio.cc,v
retrieving revision 2.5
diff -u -p -r2.5 netio.cc
--- netio.cc	2001/12/02 03:25:11	2.5
+++ netio.cc	2001/12/20 12:36:00
@@ -229,29 +229,29 @@ auth_proc (HWND h, UINT message, WPARAM 
 }
 
 static int
-auth_common (HINSTANCE h, int id)
+auth_common (HINSTANCE h, int id, HWND owner)
 {
-  return DialogBox (h, MAKEINTRESOURCE (id), 0, auth_proc);
+  return DialogBox (h, MAKEINTRESOURCE (id), owner, auth_proc);
 }
 
 int
-NetIO::get_auth ()
+NetIO::get_auth (HWND owner)
 {
   user = &net_user;
   passwd = &net_passwd;
-  return auth_common (hinstance, IDD_NET_AUTH);
+  return auth_common (hinstance, IDD_NET_AUTH, owner);
 }
 
 int
-NetIO::get_proxy_auth ()
+NetIO::get_proxy_auth (HWND owner)
 {
   user = &net_proxy_user;
   passwd = &net_proxy_passwd;
-  return auth_common (hinstance, IDD_PROXY_AUTH);
+  return auth_common (hinstance, IDD_PROXY_AUTH, owner);
 }
 
 int
-NetIO::get_ftp_auth ()
+NetIO::get_ftp_auth (HWND owner)
 {
   if (net_ftp_user)
     {
@@ -267,5 +267,5 @@ NetIO::get_ftp_auth ()
     return IDCANCEL;
   user = &net_ftp_user;
   passwd = &net_ftp_passwd;
-  return auth_common (hinstance, IDD_FTP_AUTH);
+  return auth_common (hinstance, IDD_FTP_AUTH, owner);
 }
Index: netio.h
===================================================================
RCS file: /cvs/src/src/winsup/cinstall/netio.h,v
retrieving revision 2.4
diff -u -p -r2.4 netio.h
--- netio.h	2001/12/02 03:25:11	2.4
+++ netio.h	2001/12/20 12:36:00
@@ -50,7 +50,7 @@ public:
   /* Helper functions for http/ftp protocols.  Both return nonzero for
      "cancel", zero for "ok".  They set net_proxy_user, etc, in
      state.h */
-  int get_auth ();
-  int get_proxy_auth ();
-  int get_ftp_auth ();
+  int get_auth (HWND owner);
+  int get_proxy_auth (HWND owner);
+  int get_ftp_auth (HWND owner);
 };
Index: nio-file.cc
===================================================================
RCS file: /cvs/src/src/winsup/cinstall/nio-file.cc,v
retrieving revision 2.4
diff -u -p -r2.4 nio-file.cc
--- nio-file.cc	2001/12/02 03:25:11	2.4
+++ nio-file.cc	2001/12/20 12:36:00
@@ -45,7 +45,7 @@ NetIO (Purl)
       const char *err = strerror (errno);
       if (!err)
 	err = "(unknown error)";
-      note (IDS_ERR_OPEN_READ, path, err);
+      note (NULL, IDS_ERR_OPEN_READ, path, err);
     }
 }
 
Index: nio-ftp.cc
===================================================================
RCS file: /cvs/src/src/winsup/cinstall/nio-ftp.cc,v
retrieving revision 2.8
diff -u -p -r2.8 nio-ftp.cc
--- nio-ftp.cc	2001/12/02 03:25:11	2.8
+++ nio-ftp.cc	2001/12/20 12:36:02
@@ -95,7 +95,7 @@ NetIO_FTP::NetIO_FTP (char const *Purl, 
 	}
       if (code == 530)		/* Authentication failed, retry */
 	{
-	  get_ftp_auth ();
+	  get_ftp_auth (NULL);
 	  if (net_ftp_user && net_ftp_passwd)
 	    goto auth_retry;
 	}
Index: nio-http.cc
===================================================================
RCS file: /cvs/src/src/winsup/cinstall/nio-http.cc,v
retrieving revision 2.9
diff -u -p -r2.9 nio-http.cc
--- nio-http.cc	2001/12/02 03:25:11	2.9
+++ nio-http.cc	2001/12/20 12:36:02
@@ -148,14 +148,14 @@ retry_get:
     }
   if (code == 401)		/* authorization required */
     {
-      get_auth ();
+      get_auth (NULL);
       delete
 	s;
       goto retry_get;
     }
   if (code == 407)		/* proxy authorization required */
     {
-      get_proxy_auth ();
+      get_proxy_auth (NULL);
       delete
 	s;
       goto retry_get;
@@ -163,7 +163,7 @@ retry_get:
   if (code == 500		/* ftp authentication through proxy required */
       && net_method == IDC_NET_PROXY && !strncmp (url, "ftp://", 6))
     {
-      get_ftp_auth ();
+      get_ftp_auth (NULL);
       if (net_ftp_user && net_ftp_passwd)
 	{
 	  delete
Index: nio-ie5.cc
===================================================================
RCS file: /cvs/src/src/winsup/cinstall/nio-ie5.cc,v
retrieving revision 2.4
diff -u -p -r2.4 nio-ie5.cc
--- nio-ie5.cc	2001/12/02 03:25:11	2.4
+++ nio-ie5.cc	2001/12/20 12:36:02
@@ -44,7 +44,7 @@ NetIO (_url)
       HINSTANCE h = LoadLibrary ("wininet.dll");
       if (!h)
 	{
-	  note (IDS_WININET);
+	  note (NULL, IDS_WININET);
 	  connection = 0;
 	  return;
 	}
@@ -112,14 +112,14 @@ try_again:
 	  if (type == 401)	/* authorization required */
 	    {
 	      flush_io ();
-	      get_auth ();
+	      get_auth (NULL);
 	      resend = 1;
 	      goto try_again;
 	    }
 	  else if (type == 407)	/* proxy authorization required */
 	    {
 	      flush_io ();
-	      get_proxy_auth ();
+	      get_proxy_auth (NULL);
 	      resend = 1;
 	      goto try_again;
 	    }
Index: other.cc
===================================================================
RCS file: /cvs/src/src/winsup/cinstall/other.cc,v
retrieving revision 2.3
diff -u -p -r2.3 other.cc
--- other.cc	2001/12/03 22:22:09	2.3
+++ other.cc	2001/12/20 12:36:02
@@ -103,12 +103,12 @@ dialog_proc (HWND h, UINT message, WPARA
 }
 
 void
-do_other (HINSTANCE h)
+do_other (HINSTANCE h, HWND owner)
 {
   int rv = 0;
-  rv = DialogBox (h, MAKEINTRESOURCE (IDD_OTHER_URL), 0, dialog_proc);
+  rv = DialogBox (h, MAKEINTRESOURCE (IDD_OTHER_URL), owner, dialog_proc);
   if (rv == -1)
-    fatal (IDS_DIALOG_FAILED);
+    fatal (owner, IDS_DIALOG_FAILED);
 
   log (0, "site: %s", other_url);
 }
Index: postinstall.cc
===================================================================
RCS file: /cvs/src/src/winsup/cinstall/postinstall.cc,v
retrieving revision 2.4
diff -u -p -r2.4 postinstall.cc
--- postinstall.cc	2001/11/13 01:49:32	2.4
+++ postinstall.cc	2001/12/20 12:36:02
@@ -98,7 +98,7 @@ static const char *shells[] = {
 };
 
 void
-do_postinstall (HINSTANCE h)
+do_postinstall (HINSTANCE h, HWND owner)
 {
   next_dialog = 0;
   int i;
